#ifndef WTRUNTIME_UNICODE_H
#define WTRUNTIME_UNICODE_H

#include "config.h"

#define UTF_MAX_VALUE          0x10ffff
#define UTF_RESERVED_START     0xD800
#define UTF_RESERVED_END       0xDFFF

#define UTF16_HIGH_SURROGATE   0xD800
#define UTF16_LOW_SURROGATE    0xDC00
#define UTF16_DATA_BITS        10
#define UTF16_DATA_MASK        0x3FF

#define UTF8_LAST_1            0x7F
#define UTF8_LAST_2            0x7FF
#define UTF8_LAST_3            0xFFFF
#define UTF8_LAST_4            0x1FFFFF
#define UTF8_CSEQ              0x80 /* sequence continue */
#define UTF8_CSEQ_BITS         6
#define UTF8_CSEQ_DATA_MASK    0x3F
#define UTF8_SEQ2              0xC0
#define UTF8_SEQ2_BITS         5
#define UTF8_SEQ2_DATA_MASK    0x1F
#define UTF8_SEQ3              0xE0
#define UTF8_SEQ3_BITS         4
#define UTF8_SEQ3_DATA_MASK    0xF
#define UTF8_SEQ4              0xF0
#define UTF8_SEQ4_BITS         3
#define UTF8_SEQ4_DATA_MASK    0x7

#endif /* WTRUNTIME_UNICODE_H */
